<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        ViewState("SortExpr") = "DateAdded ASC"
        BindData(ViewState("SortExpr"))
      End If
    End Sub
    
    
    Sub BindData(sortExpr as String)
      '1. Create a connection
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Dim strSQL as String
      strSQL = "SELECT CommentID, Name, Comment, DateAdded " & _
              "FROM Comments ORDER BY " & sortExpr
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      '3. Create a DataAdapter and Fill the DataSet
      Dim objDA as New SqlDataAdapter()
      objDA.SelectCommand = objCmd
    
      objConn.Open()
    
      Dim objDS as DataSet = New DataSet()
      objDA.Fill(objDS, "titles")
    
      objConn.Close()
    
      'Finally, specify the DataSource and call DataBind()
      dgComments.DataSource = objDS
      dgComments.DataBind()
    
      objConn.Close()   'Close the connection
    
      ShowPageInformation()
    End Sub
    
    
    Sub ShowPageInformation()
      'This sub displays paging information in the appropriate label
      lblPagingInfo.Text = "Displaying Page " & _
           (dgComments.CurrentPageIndex+1).ToString() & " of " & _
           dgComments.PageCount
    End Sub
    
    
    Sub dgComments_Paging(sender As Object, e As DataGridPageChangedEventArgs)
      dgComments.CurrentPageIndex = e.NewPageIndex
      BindData(ViewState("SortExpr"))
    End Sub
    
    
    Sub dgComments_Sorting(sender as Object, e as DataGridSortCommandEventArgs)
      'Set the sortExpr ViewState variable accordingly
      ViewState("SortExpr") = e.SortExpression
    
      'Reset the data to show the FIRST page of data
      dgComments.CurrentPageIndex = 0
    
      'Bind the data!
      BindData(ViewState("SortExpr"))
    End Sub

</script>
<form runat="server">  
  <asp:DataGrid runat="server" id="dgComments"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AutoGenerateColumns="False" Width="75%"
      PageSize="10" AllowPaging="True"
      OnPageIndexChanged="dgComments_Paging"
      AllowSorting="True" OnSortCommand="dgComments_Sorting">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
             
    <PagerStyle BackColor="Navy" ForeColor="White" Font-Size="8pt"
             Font-Bold="True" HorizontalAlign="Right"
             NextPageText="Next >" PrevPageText="< Prev" />
             
    <Columns>
      <asp:BoundColumn DataField="Name" HeaderText="Name"
           SortExpression="Name" />
      <asp:BoundColumn DataField="Comment" HeaderText="Comment"
           SortExpression="Comment" />
      <asp:BoundColumn DataField="DateAdded" HeaderText="Date Added"
          SortExpression="DateAdded"
          ItemStyle-HorizontalAlign="Center" DataFormatString="{0:d}" />
    </Columns>
  </asp:DataGrid>
  <asp:label id="lblPagingInfo" runat="server" Font-Name="Verdana"
     Font-Size="9pt" Font-Italic="True" Width="75%" HorizontalAlign="Right" />
</form>
