<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        ViewState("SortExpr") = "DateAdded ASC"
        BindData(ViewState("SortExpr"))
      End If
    End Sub
    
    
    Sub BindData(sortExpr as String)
      '1. Create a connection
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Dim strSQL as String
      strSQL = "SELECT CommentID, Name, Comment, DateAdded " & _
              "FROM Comments ORDER BY " & sortExpr
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      '3. Create a DataAdapter and Fill the DataSet
      Dim objDA as New SqlDataAdapter()
      objDA.SelectCommand = objCmd
    
      objConn.Open()
    
      Dim objDS as DataSet = New DataSet()
      objDA.Fill(objDS, "titles")
    
      objConn.Close()
    
      'Finally, specify the DataSource and call DataBind()
      dgComments.DataSource = objDS
      dgComments.DataBind()
    
      objConn.Close()   'Close the connection
    
      ShowPageInformation()
    End Sub
    
    
    Sub ShowPageInformation()
      'This sub displays paging information in the appropriate label
      lblPagingInfo.Text = "Displaying Page " & _
           (dgComments.CurrentPageIndex+1).ToString() & " of " & _
           dgComments.PageCount
    End Sub
    
    
    Sub dgComments_Paging(sender As Object, e As DataGridPageChangedEventArgs)
      'Turn off editing
      dgComments.EditItemIndex = -1
    
      dgComments.CurrentPageIndex = e.NewPageIndex
      BindData(ViewState("SortExpr"))
    End Sub
    
    
    Sub dgComments_Sorting(sender as Object, e as DataGridSortCommandEventArgs)
      'Set the sortExpr ViewState variable accordingly
      ViewState("SortExpr") = e.SortExpression
    
      'Reset the data to show the FIRST page of data
      dgComments.CurrentPageIndex = 0
    
      'Turn off editing
      dgComments.EditItemIndex = -1
    
      'Bind the data!
      BindData(ViewState("SortExpr"))
    End Sub
    
    
    Sub dgComments_EditRow(sender As Object, e As DataGridCommandEventArgs)
      dgComments.EditItemIndex = e.Item.ItemIndex
      BindData(ViewState("SortExpr"))
    End Sub
    
    Sub dgComments_UpdateRow(sender As Object, e As DataGridCommandEventArgs)
      'Make sure the Page is Valid
      If Not Page.Isvalid Then Exit Sub
    
      'Get information from columns...
      Dim nameTextBox as TextBox = e.Item.Cells(1).FindControl("txtName")
      Dim commentTextBox as TextBox = e.Item.Cells(2).FindControl("txtComment")
      Dim dateAdded as Calendar = e.Item.Cells(3).FindControl("calDate")
    
      Dim iCommentID as Integer = dgComments.DataKeys(e.Item.ItemIndex)
    
    
      'Update the database...
      Dim strSQL as String
      strSQL = "UPDATE Comments SET Name = @NameParam, DateAdded = @DateAddedParam, " & _
               "Comment = @CommentParam WHERE CommentID = @CommentIDParam"
    
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      Dim nameParam as New SqlParameter("@NameParam", SqlDbType.VarChar, 50)
      Dim commentParam as New SqlParameter("@CommentParam", SqlDbType.VarChar, 255)
      Dim dateAddedParam as New SqlParameter("@DateAddedParam", SqlDbType.DateTime)
      Dim commentIDParam as New SqlParameter("@CommentIDParam", SqlDbType.Int, 4)
    
      nameParam.Value = nameTextBox.Text
      objCmd.Parameters.Add(nameParam)
    
      commentParam.Value = commentTextBox.Text
      objCmd.Parameters.Add(commentParam)
    
      dateAddedParam.Value = dateAdded.SelectedDate
      objCmd.Parameters.Add(dateAddedParam)
    
      commentIDParam.Value = iCommentID
      objCmd.Parameters.Add(commentIDParam)
    
      'Issue the SQL command
      objConn.Open()
      objCmd.ExecuteNonQuery()
      objConn.Close()
    
      dgComments.EditItemIndex = -1
      BindData(ViewState("SortExpr"))
    End Sub
    
    Sub dgComments_CancelRow(sender As Object, e As DataGridCommandEventArgs)
      dgComments.EditItemIndex = -1
      BindData(ViewState("SortExpr"))
    End Sub
    
    Sub dgComments_DeleteRow(sender As Object, e As DataGridCommandEventArgs)
      'Turn off editing
      dgComments.EditItemIndex = -1
    
      Dim iCommentID as Integer
      iCommentID = dgComments.DataKeys(e.Item.ItemIndex)
    
      'Update the database...
      Dim strSQL as String
      strSQL = "DELETE FROM Comments WHERE CommentID = @CommentIDParam"
    
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      Dim commentIDParam as New SqlParameter("@CommentIDParam", SqlDbType.Int, 4)
      commentIDParam.Value = iCommentID
      objCmd.Parameters.Add(commentIDParam)
    
      'Issue the SQL command
      objConn.Open()
      objCmd.ExecuteNonQuery()
      objConn.Close()
    
      BindData(ViewState("SortExpr"))
    End Sub
    
    Sub dgComments_RowDataBound(sender as Object, e As DataGridItemEventArgs)
      If e.Item.ItemType <> ListItemType.Header AND _
            e.Item.ItemType <> ListItemType.Footer then
        Dim deleteButton as LinkButton = e.Item.Cells(1).Controls(0)
    
        'We can now add the onclick event handler
        deleteButton.Attributes("onclick") = "javascript:return " & _
             "confirm('Are you sure you want to delete the following comment?');"
      End If
    End Sub

</script>
<form runat="server">  
  <asp:DataGrid runat="server" id="dgComments"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AutoGenerateColumns="False" Width="75%"
      PageSize="10" AllowPaging="True"
      OnPageIndexChanged="dgComments_Paging"
      AllowSorting="True" OnSortCommand="dgComments_Sorting"
      OnEditCommand="dgComments_EditRow"
      OnUpdateCommand="dgComments_UpdateRow"
      OnCancelCommand="dgComments_CancelRow"
      DataKeyField="CommentID"
      OnDeleteCommand="dgComments_DeleteRow"
      OnItemDataBound="dgComments_RowDataBound">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
             
    <PagerStyle BackColor="Navy" ForeColor="White" Font-Size="8pt"
             Font-Bold="True" HorizontalAlign="Right"
             NextPageText="Next >" PrevPageText="< Prev" />
             
    <Columns>
      <asp:EditCommandColumn EditText="Edit" UpdateText="Update"
           CancelText="Cancel" ButtonType="LinkButton" />
      <asp:ButtonColumn Text="Delete" ButtonType="LinkButton"
           CommandName="Delete" />
      <asp:TemplateColumn HeaderText="Name" SortExpression="Name">
        <ItemTemplate>
          <%# DataBinder.Eval(Container.DataItem, "Name") %>
        </ItemTemplate>
        <EditItemTemplate>
          <asp:TextBox runat="server" id="txtName" Columns="15"
              MaxLength="50" Font-Name="Verdana" Font-Size="9pt"
              Text='<%# DataBinder.Eval(Container.DataItem, "Name") %>' />
          <asp:RequiredFieldValidator runat="server"
              ControlToValidate="txtName" Display="Dynamic"
              ErrorMessage="<br />You must provide a Name." />
        </EditItemTemplate>
      </asp:TemplateColumn>
      <asp:TemplateColumn HeaderText="Comment" SortExpression="Comment">
        <ItemTemplate>
          <%# DataBinder.Eval(Container.DataItem, "Comment") %>
        </ItemTemplate>
        <EditItemTemplate>
          <asp:TextBox runat="server" id="txtComment" Width="95%"
              MaxLength="255" Font-Name="Verdana" Font-Size="9pt"
              TextMode="MultiLine" Rows="5"
              Text='<%# DataBinder.Eval(Container.DataItem, "Comment") %>' />
          <asp:RequiredFieldValidator runat="server"
              ControlToValidate="txtComment" Display="Dynamic"
              ErrorMessage="<br />You must provide a Comment." />
        </EditItemTemplate>
      </asp:TemplateColumn>
      <asp:TemplateColumn HeaderText="Date Added" SortExpression="DateAdded"
             ItemStyle-HorizontalAlign="Center">
        <ItemTemplate>
          <%# DataBinder.Eval(Container.DataItem, "DateAdded", "{0:d}") %>
        </ItemTemplate>
        <EditItemTemplate>
          <asp:Calendar id="calDate" runat="server"
                SelectedDate='<%# Convert.ToDateTime(DataBinder.Eval(Container.DataItem, "DateAdded")) %>'
                VisibleDate='<%# Convert.ToDateTime(DataBinder.Eval(Container.DataItem, "DateAdded")) %>' />
        </EditItemTemplate>      
      </asp:TemplateColumn>          
    </Columns>
  </asp:DataGrid>
  <asp:label id="lblPagingInfo" runat="server" Font-Name="Verdana"
     Font-Size="9pt" Font-Italic="True" Width="75%" HorizontalAlign="Right" />
</form>
