Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls

Public Class LimitColumn
    Inherits BoundColumn

    Private m_charLimit As Integer

    Public Property CharacterLimit() As Integer = -1
        Get
            Return m_charLimit
        End Get
        Set(ByVal Value As Integer)
            If Value >= 0 Then
                m_charLimit = Value
            Else
                m_charLimit = -1
            End If
        End Set
    End Property

    Protected Overrides Function FormatDataValue(ByVal dataValue As Object) As String
        Dim result As String = MyBase.FormatDataValue(dataValue)

        If m_charLimit = -1 Then
            'No restrictions should be applied to the length
            Return result
        Else
            'Only show the first m_charLimit characters
            If result.Length < m_charLimit Then
                Return result
            Else
                Return result.Substring(0, m_charLimit) & "..."
            End If

        End If
    End Function

End Class
