using System;
using System.Collections;

public class FibSeries : IEnumerable
{
  // we must have something to enumerate over, 
  // let's just use an integer array
  int [] data;

  public FibSeries(int size)
  {
    // create the array
    data = new int[size];

    // populate the array
    data[0] = 1;
    data[1] = 1;

    for (int i = 2; i < size; i++)
      data[i] = data[i-1] + data[i-2];
  }

  // since we implement IEnumerable we must provide a GetEnumerator method
  public IEnumerator GetEnumerator()
  {
    // simply return the array's enumerator
    return data.GetEnumerator();
  }
}