<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="C#">

    void Page_Load(Object sender, EventArgs e)
    {
      AddFilterButtons();

      if (!Page.IsPostBack)
         //Populate the DataGrid
         BindData(String.Empty);      
    }
    
    
    void BindData(String filterValue)
    {
      DisplayViewingTypeMessage(filterValue);
      
      // 1. Create a connection
       const string strConnString = "server=localhost;uid=sa;pwd=;database=pubs";
       SqlConnection objConn = new SqlConnection(strConnString);
    
      
      // Create an appropriate SQL command string
      String strSQL;
      if (filterValue == String.Empty)
        strSQL = "SELECT * FROM titles";
      else
        // SQL needs WHERE clause
        strSQL = "SELECT * FROM titles WHERE type = @TYPE";
      
      
      // 2. Create a command object for the query
      SqlCommand objCmd = new SqlCommand(strSQL, objConn);

      // Add parameter for WHERE clause if needed
      if (strSQL != String.Empty)
      {
        SqlParameter filterParam = new SqlParameter("@TYPE", SqlDbType.Char, 12);
        filterParam.Value = filterValue;
        objCmd.Parameters.Add(filterParam);
      }
    
      objConn.Open();
    
      // Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection);
      dgTitles.DataBind();
    
      objConn.Close();
    }

    
    void FilterData(Object sender, CommandEventArgs e)
    {  BindData(e.CommandArgument.ToString());  }
    
    
    void DisplayViewingTypeMessage(String filterValue)
    {
      if (filterValue == String.Empty)
        lblViewingMsg.Text = "You are viewing all books...";
      else
        lblViewingMsg.Text = "You are viewing books of type " + filterValue;      
    }
    
    
    void AddFilterButtons()
    {
      //Dynamically add the control buttons
      //1. Create a connection
       const string strConnString = "server=localhost;uid=sa;pwd=;database=pubs";
       SqlConnection objConn = new SqlConnection(strConnString);
    
      
      // Create an appropriate SQL command string
      const string strSQL = "SELECT DISTINCT type FROM titles ORDER BY type";
      
       // 2. Create a command object for the query
       SqlCommand objCmd = new SqlCommand(strSQL, objConn);

       objConn.Open();
       SqlDataReader dr  = objCmd.ExecuteReader();
         
       // Add the View ALL button
       Button filterButton = new Button();
       filterButton.Text = "View ALL Books";
       filterButton.CommandArgument = "";
       filterButtonLocation.Controls.Add(filterButton);
       filterButton.Command += new CommandEventHandler(this.FilterData);
         
       // Now, loop through the SqlDataReader, adding buttons
       while(dr.Read())
       {
         filterButton = new Button();
         filterButton.Text = "View Books of Type " + dr["type"].ToString();
         filterButton.CommandArgument = dr["type"].ToString();
         filterButton.Command += new CommandEventHandler(this.FilterData);
           
         filterButtonLocation.Controls.Add(filterButton);
       }
    
       objConn.Close();
    }

</script>

<form runat="server">
  <asp:PlaceHolder runat="server" id="filterButtonLocation" />
  <p>
    <asp:label id="lblViewingMsg" runat="server" Font-Name="Verdana"
           Font-Italic="True" Font-Color="Red" />
  </p> 
  <asp:DataGrid runat="server" id="dgTitles"
      AutoGenerateColumns="False"  CellPadding="5"
      Font-Name="Verdana"  Font-Size="9pt"
      AlternatingItemStyle-BackColor="#dddddd">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
              
    <Columns>
      <asp:BoundColumn DataField="title_id" HeaderText="Title ID"
             ItemStyle-HorizontalAlign="Center" />
      <asp:BoundColumn DataField="title" HeaderText="Title" />
      <asp:BoundColumn DataField="type" HeaderText="Type" />
    </Columns>
  </asp:DataGrid>
</form>    
