<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        ViewState("titleSortDirection") = "ASC"
        ViewState("priceSortDirection") = "ASC"
        
        PrepareBindData("title", ViewState("titleSortDirection"))
        ChangeHeaderImageUrl("title", "ASC")
        SwapDirection("titleSortDirection")
      End If
    End Sub
    
    
    Sub ChangeHeaderImageUrl(fieldName as String, sortDirection as String)
      ' Loop through all of the DataGrid columns
      Dim iLoop as Integer
      Dim column as DataGridColumn
      Dim dgRow as DataGridItem = dgTitles.Controls(0).Controls(0)
      Dim sortButton as ImageButton

      For iLoop = 0 to dgTitles.Columns.Count - 1
      
        column = dgTitles.Columns(iLoop)
      
        ' See if the column has a SortExpression property
        If column.SortExpression <> String.Empty then          
          'Now, check if the SortExpression equals the fieldName
          
          sortButton = dgRow.Cells(iLoop).Controls(0)
          
          If column.SortExpression = fieldName then
            'We need to apply a new arrow direction
            column.HeaderImageUrl = fieldName & sortDirection & ".gif"
            sortButton.ImageUrl = column.HeaderImageUrl
          Else
            'This column wasn't sorted, we need to display the
            'standard image url
            column.HeaderImageUrl = column.SortExpression & "Plain.gif"
            sortButton.ImageUrl = column.HeaderImageUrl
          End If
        End If
      Next iLoop
    End Sub
    
    
    Sub SwapDirection(viewStateKey as String)
      If ViewState(viewStateKey) = "ASC" then
        ViewState(viewStateKey) = "DESC"
      Else
        ViewState(viewStateKey) = "ASC"
      End If   
    End Sub
    
    
    Sub PrepareBindData(fieldName as String, sortDirection as String)
      If fieldName = "price" then
        BindData(fieldName & " " & sortDirection & ", title ASC")
      Else
        BindData(fieldName & " " & sortDirection)
      End If
    End Sub
    
    
    Sub BindData(SortFieldName as String)
      'Check to see if we have a DataSet in the Viewstate
      Dim objDS as DataSet
      
      If ViewState("TitlesDataSet") is Nothing then
        '1. Create a connection
        Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
        Dim objConn as New SqlConnection(strConnString)
        
        '2. Create a command object for the query
        Dim strSQL as String
        strSQL = "SELECT title, price, pubdate " & _
                "FROM titles " & _
                "ORDER BY " & SortFieldName
        
        Dim objCmd as New SqlCommand(strSQL, objConn)
        
        '3. Create a DataAdapter and Fill the DataSet
        Dim objDA as New SqlDataAdapter()
        objDA.SelectCommand = objCmd
        
        objDS = New DataSet()
        objDA.Fill(objDS, "titles")
        
        objConn.Close()
            
        'Add the DataSet to the ViewState
        ViewState.Add("TitlesDataSet", objDS)
      Else
        'Get the DataSet out of the ViewState
        objDS = ViewState("TitlesDataSet")
        
        'Apply the sorting
        objDS.Tables("titles").DefaultView.Sort = SortFieldName
      End If
    
      'Finally, specify the DataSource and call DataBind()
      dgTitles.DataSource = objDS.Tables("titles").DefaultView
      dgTitles.DataBind()
    End Sub


    Sub SortDataGrid(sender as Object, e as DataGridSortCommandEventArgs)      
      PrepareBindData(e.SortExpression, ViewState(e.SortExpression & "SortDirection"))

      ChangeHeaderImageUrl(e.SortExpression, ViewState(e.SortExpression & "SortDirection"))
      
      SwapDirection(e.SortExpression & "SortDirection")
    End Sub
</script>
<form runat="server">
  <asp:DataGrid runat="server" id="dgTitles"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AllowSorting="True" AutoGenerateColumns="False"
      OnSortCommand="SortDataGrid">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
              
    <Columns>
      <asp:BoundColumn DataField="title" HeaderImageUrl="TitlePlain.gif"
              SortExpression="title" />
      <asp:BoundColumn DataField="price" HeaderImageUrl="PricePlain.gif"
              SortExpression="price" DataFormatString="{0:c}"
              ItemStyle-HorizontalAlign="Right" />
      <asp:BoundColumn DataField="pubdate" HeaderText="Published Date" />
    </Columns>
  </asp:DataGrid>
</form>
