<%@ Page Language="vb" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        dgComments.VirtualItemCount = GetTotalItemsInQuery()
        ViewState("LowID") = 0
    
        Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
        Dim objConn as New SqlConnection(strConnString)
        Dim strSQL as String
    
        strSQL = "SELECT TOP " & dgComments.PageSize & " CommentID, Name, " & _
                "Comment, DateAdded " & _
                "FROM Comments " & _
                "WHERE CommentID > 0 " & _
                "ORDER BY CommentID ASC"
    
        'Get the results
        Dim objCmd as New SqlCommand(strSQL, objConn)
    
        objConn.Open()
        BindData(objCmd)
        objConn.Close()
      End If
    End Sub
    
    
    Sub BindData(objCmd as SqlCommand)
      'Create a DataAdapter and Fill the DataSet
      Dim objDA as New SqlDataAdapter()
      objDA.SelectCommand = objCmd
    
      Dim objDS as DataSet = New DataSet()
      objDA.Fill(objDS, "titles")
    
      'Get a DataView from the DataSet's "titles" DataTable
      Dim myDataView as DataView = New DataView(objDS.Tables("titles"))
    
      'Sort the DataView on the commentID
      myDataView.Sort = "CommentID ASC"
    
      'Bind the dataView to the DataGrid
      dgComments.DataSource = myDataView
      dgComments.DataBind()
    
      'Now, get the high and low IDs
       ViewState("LowID") = myDataView(0)("CommentID")
       ViewState("HighID") = myDataView(myDataView.Count-1)("CommentID")
    End Sub
    
    
    Sub dgComments_Paging(sender As Object, e As DataGridPageChangedEventArgs)
      'See if the user is visiting the next page or previous page
      'Create a connection
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
      Dim strSQL as String
      Dim objCmd as New SqlCommand()
      Dim IDParam as New SqlParameter("@IDParam", SqlDbType.Int, 4)
    
      If dgComments.CurrentPageIndex = e.NewPageIndex - 1 then
        'The user wants to see the next page
         strSQL = "SELECT TOP " & dgComments.PageSize & " CommentID, Name, " & _
                "Comment, DateAdded " & _
                "FROM Comments " & _
                "WHERE CommentID > @IDParam " & _
                "ORDER BY CommentID ASC"
    
         IDParam.Value = ViewState("HighID")
      Else
        'The user wants to see the previous page
         strSQL = "SELECT TOP " & dgComments.PageSize & " CommentID, Name, " & _
                "Comment, DateAdded " & _
                "FROM Comments " & _
                "WHERE CommentID < @IDParam " & _
                "ORDER BY CommentID DESC"
    
         IDParam.Value = ViewState("LowID")
       End If
    
       'Set the CurrentPageIndex property
       dgComments.CurrentPageIndex = e.NewPageIndex
    
       'Get the results
       objCmd.Parameters.Add(IDParam)
    
       objCmd.CommandText = strSQL
       objCmd.Connection = objConn
    
       objConn.Open()
       BindData(objCmd)
       objConn.Close()
    End Sub
    
    
    Function GetTotalItemsInQuery()
      '1. Create a connection
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Dim strSQL as String
      strSQL = "SELECT COUNT(*) FROM Comments"
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      ' Get the number of records
      Dim recCount as Integer
      recCount = objCmd.ExecuteScalar()
    
      objConn.Close()
    
      Return recCount
    End Function

</script>
<form runat="server">
  <asp:DataGrid runat="server" id="dgComments"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AutoGenerateColumns="True" Width="75%"
      PageSize="10" AllowPaging="True"
      OnPageIndexChanged="dgComments_Paging"
      AllowCustomPaging="True">

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
             
    <PagerStyle BackColor="Navy" ForeColor="White" Font-Size="8pt"
             Font-Bold="True" HorizontalAlign="Right"
             Mode="NextPrev" NextPageText="Next >" PrevPageText="< Prev" />
  </asp:DataGrid>
</form>