<%@ Page Language="vb" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Dim ddlDataSet as DataSet = New DataSet()
    
    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        BindData()
      End If
    End Sub
    
    
    Sub BindData()
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Dim strSQL as String = _
        "SELECT title_id, title, t.pub_id, p.pub_name, price FROM titles t " & _
        "INNER JOIN publishers p ON t.pub_id = p.pub_id ORDER BY title"
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgTitle.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgTitle.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Function GetPublishers() as DataSet
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Const strSQL as String = _
        "SELECT pub_id, pub_name FROM publishers ORDER BY pub_name"
    
      Dim myDataAdapter as SqlDataAdapter
      myDataAdapter = New SqlDataAdapter(strSQL, objConn)
    
      'Fill the DataSet
      objConn.Open()    'Open the connection
      myDataAdapter.Fill(ddlDataSet, "Publishers")
      objConn.Close()   'Close the connection
    
      Return ddlDataSet 'Return the DataSet
    End Function
    
    
    Function GetSelectedIndex(pub_id as String) as Integer
      'Loop through the DataSet ddlDataSet
      Dim iLoop as Integer
      Dim dt as DataTable = ddlDataSet.Tables("Publishers")
      For iLoop = 0 to dt.Rows.Count - 1
        If pub_id = dt.Rows(iLoop)("pub_id").ToString() then
          Return iLoop
        End If
      Next iLoop
    End Function
    
    
    Sub dgTitle_EditRow(sender As Object, e As DataGridCommandEventArgs)
      dgTitle.EditItemIndex = e.Item.ItemIndex
      BindData()
    End Sub
    
    Sub dgTitle_UpdateRow(sender As Object, e As DataGridCommandEventArgs)
      'Get information from columns...
      Dim ddlPublishers as DropDownList = e.Item.Cells(2).FindControl("ddlPublisher")
    
      Dim titleID as String = dgTitle.DataKeys(e.Item.ItemIndex)
    
    
      'Update the database...
      Dim strSQL as String
      strSQL = "UPDATE titles SET pub_id = @pubIDParam " & _
               "WHERE title_id = @titleIDParam"
    
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      Dim pubIDParam as New SqlParameter("@pubIDParam", SqlDbType.Char, 4)
      Dim titleIDParam as New SqlParameter("@titleIDParam", SqlDbType.VarChar, 6)
    
      pubIDParam.Value = ddlPublishers.SelectedItem.Value
      objCmd.Parameters.Add(pubIDParam)
    
      titleIDParam.Value = titleID
      objCmd.Parameters.Add(titleIDParam)
    
      'Issue the SQL command
      objConn.Open()
      objCmd.ExecuteNonQuery()
      objConn.Close()
    
      dgTitle.EditItemIndex = -1
      BindData()
    End Sub
    
    Sub dgTitle_CancelRow(sender As Object, e As DataGridCommandEventArgs)
      dgTitle.EditItemIndex = -1
      BindData()
    End Sub

</script>
<form runat="server">
  <asp:DataGrid runat="server" id="dgTitle"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AutoGenerateColumns="False" DataKeyField="title_id"
      OnEditCommand="dgTitle_EditRow"
      OnUpdateCommand="dgTitle_UpdateRow"
      OnCancelCommand="dgTitle_CancelRow">     

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
    
    <Columns>
      <asp:EditCommandColumn ButtonType="LinkButton" HeaderText="Edit"
            EditText="Edit" UpdateText="Update" CancelText="Cancel" />
      <asp:BoundColumn DataField="title"
                HeaderText="Title" ReadOnly="True" />      
      <asp:TemplateColumn HeaderText="Publisher">
        <ItemTemplate>
          <%# DataBinder.Eval(Container.DataItem, "pub_name") %>
        </ItemTemplate>
        <EditItemTemplate>
          <asp:DropDownList id="ddlPublisher" runat="server"
              DataTextField="pub_name"
              DataValueField="pub_id"
              DataSource="<%# GetPublishers() %>"
              SelectedIndex='<%# GetSelectedIndex(Container.DataItem("pub_id")) %>'
              />
        </EditItemTemplate>       
      </asp:TemplateColumn>
      <asp:BoundColumn DataField="price" DataFormatString="{0:c}"
                HeaderText="Price" ReadOnly="True" />
    </Columns>
  </asp:DataGrid>
</form>
