<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server" language="VB">

    Sub Page_Load(sender as Object, e as EventArgs)
      If Not Page.IsPostBack then
        BindData()
      End If
    End Sub
    
    
    Sub BindData()
      '1. Create a connection
       Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
       Dim objConn as New SqlConnection(strConnString)
    
      '2. Create a command object for the query
      Const strSQL as String = _
        "SELECT CommentID, Name, Comment, DateAdded FROM Comments ORDER BY CommentID"
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      objConn.Open()   'Open the connection
    
      'Finally, specify the DataSource and call DataBind()
      dgComments.DataSource = objCmd.ExecuteReader(CommandBehavior.CloseConnection)
      dgComments.DataBind()
    
      objConn.Close()   'Close the connection
    End Sub
    
    
    Sub dgComments_EditRow(sender As Object, e As DataGridCommandEventArgs)
      dgComments.EditItemIndex = e.Item.ItemIndex
      BindData()
    End Sub
    
    Sub dgComments_UpdateRow(sender As Object, e As DataGridCommandEventArgs)
      'Make sure the Page is Valid!
      If Not Page.IsValid then Exit Sub
    
      'Get information from columns...
      Dim nameTextBox as TextBox = e.Item.Cells(2).Controls(0)
      Dim commentTextBox as TextBox = e.Item.Cells(3).FindControl("txtComment")
    
      Dim iCommentID as Integer = dgComments.DataKeys(e.Item.ItemIndex)
    
    
      'Update the database...
      Dim strSQL as String
      strSQL = "UPDATE Comments SET Name = @NameParam, " & _
               "Comment = @CommentParam WHERE CommentID = @CommentIDParam"
    
      Const strConnString as String = "server=localhost;uid=sa;pwd=;database=pubs"
      Dim objConn as New SqlConnection(strConnString)
    
      Dim objCmd as New SqlCommand(strSQL, objConn)
    
      Dim nameParam as New SqlParameter("@NameParam", SqlDbType.VarChar, 50)
      Dim commentParam as New SqlParameter("@CommentParam", SqlDbType.VarChar, 255)
      Dim commentIDParam as New SqlParameter("@CommentIDParam", SqlDbType.Int, 4)
    
      nameParam.Value = nameTextBox.Text
      objCmd.Parameters.Add(nameParam)
    
      commentParam.Value = commentTextBox.Text
      objCmd.Parameters.Add(commentParam)
    
      commentIDParam.Value = iCommentID
      objCmd.Parameters.Add(commentIDParam)
    
      'Issue the SQL command
      objConn.Open()
      objCmd.ExecuteNonQuery()
      objConn.Close()
    
      dgComments.EditItemIndex = -1
      BindData()
    End Sub
    
    Sub dgComments_CancelRow(sender As Object, e As DataGridCommandEventArgs)
      dgComments.EditItemIndex = -1
      BindData()
    End Sub

</script>
<form runat="server">
  <asp:DataGrid runat="server" id="dgComments"
      Font-Name="Verdana" Font-Size="9pt" CellPadding="5"
      AlternatingItemStyle-BackColor="#dddddd"
      AutoGenerateColumns="False" DataKeyField="CommentID"
      OnEditCommand="dgComments_EditRow"
      OnUpdateCommand="dgComments_UpdateRow"
      OnCancelCommand="dgComments_CancelRow">     

    <HeaderStyle BackColor="Navy" ForeColor="White" Font-Size="13pt"
              Font-Bold="True" HorizontalAlign="Center" />
    
    <Columns>
      <asp:EditCommandColumn ButtonType="LinkButton" HeaderText="Edit"
            EditText="Edit" UpdateText="Update" CancelText="Cancel" />
      <asp:BoundColumn DataField="CommentID"
                HeaderText="Comment ID" ReadOnly="True" />
      <asp:BoundColumn DataField="Name" HeaderText="Name" />
      <asp:TemplateColumn HeaderText="Comment">
        <ItemTemplate>
          <%# DataBinder.Eval(Container.DataItem, "Comment") %>
        </ItemTemplate>
        <EditItemTemplate>
          <asp:TextBox runat="server" id="txtComment" TextMode="MultiLine"
                   Columns="40" Rows="6" MaxLength="255"
                   Text='<%# DataBinder.Eval(Container.DataItem, "Comment") %>' />
                   
          <asp:RequiredFieldValidator runat="server" 
                 ControlToValidate="txtComment" Display="Dynamic"
                 ErrorMessage="<br /><i>You must provide a Comment.</i>" />
        </EditItemTemplate>       
      </asp:TemplateColumn>
      <asp:BoundColumn DataField="DateAdded" HeaderText="Date Added"
                ReadOnly="True" />
    </Columns>
  </asp:DataGrid>
</form>
